; application subwindow drawing routine for wined
; v. 1.04	2016 Jul 04 minor changes
; v. 1.03	2003 may 08 13:25:38
;  w. lenerz 1994
; the rows of the app sub window contain three sections
; the row nbr (offset from top)
; the hex data
; the alphanumeric data


	section prt_sect

	include dev1_asm_wined_includes

	xdef	draw_app
	xdef	draw_app2

	xref	nbr_sects
	xref	read_sec
	xref	set_app 	; sets wdw to appsub & sets colours (apphit)

appregs reg	d1-d7/a5

; don't read
; on entry, a0 = channel id of window
; the window must be set to the appsub window



draw_app2
	tst.w	dontread(a4)		; do we have any half?
	beq.s	dp2
draw_out
	blt.s	no_reset
	move.w	#0,dontread(a4)
dp2	movem.l appregs,-(a7)		; save regs
	bra.s	cont2
no_reset
	moveq	#0,d0
	rts

; read one sector and redraw appsub
draw_app
	tst.w	dontread(a4)		; do we draw anything?
	bne.s	draw_out		; no, so leave->...
	movem.l appregs,-(a7)
	bsr	read_sec		; read one sector

; redraw appsub
cont2	move.w	row(a4),d4		; what block do we display?
	lsl.w	#8,d4			; * $100: offset into bytes
	cmp.w	#$f,nr_rows(a4)
	beq.s	is_smal
	lsl.w	#1,d4
is_smal bsr	set_app 		; set wdw to appsub

common	moveq	#$20,d0 		; sd_clear
	trap	#3			; clear all of wdw
	move.w	nr_rows(a4),d7		; number of rows to display-1 (for dbf)
	lea	file_sp(a4),a5		; point to start of sector
	add.w	d4,a5			; add offset into sector data
	moveq	#-1,d3
	moveq	#' ',d6 		; d6 contains one space
bigloop lea	numbersp(a4),a1 	; space for row nbr + hex strings
	lea	54(a1),a2		: space for alpha num section
	move.b	d6,(a1)+		; start with a space " "
	moveq	#3,d0			; loop counter

; display the row number first
rowloop moveq	#$0,d2			; make hex nibbles for row number
	rol.w	#4,d4
	or.b	d4,d2
	andi.b	#$f,d2
	add.b	#$30,d2
	cmp.b	#$39,d2
	bls.s	chiffre
	addq.b	#7,d2
chiffre move.b	d2,(a1)+
	dbf	d0,rowloop
			    
; now fill in the rest of the row (hex + alpha data)
	move.b	d6,(a2)+
	move.b	d6,(a1)+
	moveq	#$f,d0			; loop counter
; first hex
inloop	move.b	d6,(a1)+
	move.b	(a5)+,d1		; byte to show
	move.b	d1,d2
	lsr.b	#$04,d1
	andi.b	#$f,d1
	addi.b	#$30,d1
	cmpi.b	#$39,d1
	bls.s	nohex1
	addq.b	#$07,d1
nohex1	move.b	d1,(a1)+		; first nibble
	move.b	d2,d1
	andi.b	#$f,d1
	addi.b	#$30,d1
	cmpi.b	#$39,d1 		; show as double hex number
	bls.s	nohex2
	addq.b	#$07,d1
nohex2	move.b	d1,(a1)+		; display second nibble
; now alpha
	cmpi.b	#$1f,d2 		; some chars are disayed as '.'
	bhi.s	lab1
	moveq	#$2e,d2
	bra.s	do_print
lab1	cmpi.b	#$bf,d2
	bls.s	do_print
	moveq	#$2e,d2
do_print
	move.b	d2,(a2)+		: fill in the alphnum section of the row
	dbf	d0,inloop

	move.b	#$0a,(a2)+		; pop down a row
	lea	numbersp(a4),a1
	moveq	#7,d0			; io_sstrg
	moveq	#$48,d2
	trap	#3			; send this now
	addi.w	#16,d4			; new row nbr
	dbf	d7,bigloop		; do it for 16 rows
	movem.l (a7)+,appregs		: done

	moveq	#0,d0
	moveq	#0,d4			; no hit/do
	rts

	end
